Merge remote-tracking branch 'overlays-gentoo-org/master' into prefix
authorFabian Groffen <grobian@gentoo.org>
Sun, 30 Sep 2012 11:19:55 +0000 (13:19 +0200)
committerFabian Groffen <grobian@gentoo.org>
Sun, 30 Sep 2012 11:19:55 +0000 (13:19 +0200)
Conflicts:
bin/ebuild-helpers/dobin
bin/ebuild-helpers/dodir
bin/ebuild-helpers/dodoc
bin/ebuild-helpers/doexe
bin/ebuild-helpers/doinfo
bin/ebuild-helpers/dolib
bin/ebuild-helpers/doman
bin/ebuild-helpers/domo
bin/ebuild-helpers/dosbin
bin/ebuild-helpers/ecompressdir
bin/ebuild-helpers/fperms
bin/ebuild-helpers/prepall
bin/ebuild-helpers/prepallinfo
bin/ebuild-helpers/prepallman
bin/ebuild-helpers/prepallstrip
bin/ebuild-helpers/prepinfo
bin/ebuild-helpers/preplib
bin/ebuild-helpers/prepman
bin/ebuild.sh
bin/misc-functions.sh

36 files changed:
1  2 
bin/ebuild-helpers/dobin
bin/ebuild-helpers/dodir
bin/ebuild-helpers/dodoc
bin/ebuild-helpers/doexe
bin/ebuild-helpers/dohard
bin/ebuild-helpers/doinfo
bin/ebuild-helpers/doins
bin/ebuild-helpers/dolib
bin/ebuild-helpers/doman
bin/ebuild-helpers/domo
bin/ebuild-helpers/dosbin
bin/ebuild-helpers/dosed
bin/ebuild-helpers/dosym
bin/ebuild-helpers/ecompressdir
bin/ebuild-helpers/fowners
bin/ebuild-helpers/fperms
bin/ebuild-helpers/newins
bin/ebuild-helpers/prepall
bin/ebuild-helpers/prepalldocs
bin/ebuild-helpers/prepallinfo
bin/ebuild-helpers/prepallman
bin/ebuild-helpers/prepallstrip
bin/ebuild-helpers/prepinfo
bin/ebuild-helpers/preplib
bin/ebuild-helpers/prepman
bin/ebuild-helpers/prepstrip
bin/ebuild.sh
bin/isolated-functions.sh
bin/misc-functions.sh
bin/phase-functions.sh
bin/phase-helpers.sh
bin/save-ebuild-env.sh
pym/portage/dbapi/vartree.py
pym/portage/getbinpkg.py
pym/portage/package/ebuild/doebuild.py
pym/portage/util/__init__.py

index 3d81c2d286a567ea5745cb0427e8de43d8a566eb,0ba1eb0c4e1055d1cf2c38c4b489025231150c55..2d38580781ee91649325db252f625fe3eb2b8650
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  if [[ $# -lt 1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
index 3b9a1716adad92a2e8ad8638875fc64e53fd505f,e03ba9a58085e954e2f27c1c94d327b179961ba7..779bcccb7dce81eddb33fd375943e36b1386a49c
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  install -d ${DIROPTIONS} "${@/#/${ED}/}"
  ret=$?
index 7f5e364a437beb1efd7299ffebac08d91544af79,c551735eb5340c19d40e7ee00e3a1bde3df67141..4c1c7bcd65025e3e222440ea336f6266d8c3023e
@@@ -2,19 -2,15 +2,15 @@@
  # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
- case "${EAPI}" in
-       0|1|2|3)
-               ;;
-       *)
-               exec \
-               env \
-               __PORTAGE_HELPER="dodoc" \
-               doins "$@"
-               ;;
- esac
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
+ if ___eapi_dodoc_supports_-r; then
+       exec \
+       env \
+       __PORTAGE_HELPER="dodoc" \
+       doins "$@"
+ fi
  if [ $# -lt 1 ] ; then
        __helpers_die "${0##*/}: at least one argument needed"
        exit 1  
index 9c845ca0ee89db842c879767bb437c98d97376f4,aa050e9ed417591fc0332756ce0b4d7d466de264..7ada92d05e289a0dbf3cbc37c3567dcd89515678
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  if [[ $# -lt 1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
Simple merge
index db49bedce36e6d5423ea1c230fde3aec6b7993d3,355047f73068b8bf7293ab42f181931b5eca6095..816337f1c7398f26beb39b9b12b34679b41daf05
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  if [[ -z $1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
index 343a150b2c1b612c7f5f64b1fbef5f3ba02576b9,4679e83a9a7140e100da733cb34faad384991a64..1fdc1d91b54c7ecbf51871ac3c2b2f89c8559018
@@@ -40,24 -41,12 +41,21 @@@ if [[ ${INSDESTTREE#${ED}} != "${INSDES
        __helpers_die "${helper} used with \${D} or \${ED}"
        exit 1
  fi
 +# PREFIX LOCAL: check for usage with EPREFIX
 +if [[ ${INSDESTTREE#${EPREFIX}} != "${INSDESTTREE}" ]]; then
 +      vecho "-------------------------------------------------------" 1>&2
 +      vecho "You should not use \${EPREFIX} with helpers." 1>&2
 +      vecho "  --> ${INSDESTTREE}" 1>&2
 +      vecho "-------------------------------------------------------" 1>&2
 +      exit 1
 +fi
 +# END PREFIX LOCAL
  
- case "$EAPI" in
-       0|1|2|3)
-               PRESERVE_SYMLINKS=n
-               ;;
-       *)
-               PRESERVE_SYMLINKS=y
-               ;;
- esac
+ if ___eapi_doins_and_newins_preserve_symlinks; then
+       PRESERVE_SYMLINKS=y
+ else
+       PRESERVE_SYMLINKS=n
+ fi
  
  export TMP=$T/.doins_tmp
  # Use separate directories to avoid potential name collisions.
index 67055bb55e750c9f610b51354707211bc55c43b7,fd92d7f03fa2bf99e4380ed8be975e69bd97fd3f..f161f725b3a0a8888a6329ae1f7815c0640e71d5
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  # Setup ABI cruft
  LIBDIR_VAR="LIBDIR_${ABI}"
index dd5440d7bc929fb741078e3081059e70e7f13b76,d6808597ab32d57bea18a10f15ba0c2893ce3648..8273cae336cde3ecda277d5ede9def1178dcad26
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  if [[ $# -lt 1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
index 82469733fd0dffc633815414f243a1d309732d2c,9a8dda38a41a397f14cab2c0203372fe090627c2..bb9fca2c6850d9af3b68d3febf8fe4c494cc742d
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  mynum=${#}
  if [ ${mynum} -lt 1 ] ; then
index 9765b75292e1c486b30f429f50d73193fdcb332c,361ca83ca04c294bd2198cdf795c28bc761b486b..0ddd655105fe987f1418988e4087f457d54c42cb
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  if [[ $# -lt 1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
Simple merge
Simple merge
index 464dd378c7860d2f2fa18b76bdd20de2219bc2e1,75f3e3a2516679b06fb0a86aa4a9f5f271df0b2f..83bf7fedc63566ff8f18a2dfaf2dab5ba5e37c0b
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/helper-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/helper-functions.sh
  
  if [[ -z $1 ]] ; then
        __helpers_die "${0##*/}: at least one argument needed"
index 8066ab700a9c7441922124880ea6fc0c8d6427ea,cee4108ce0f28cf6741a5a6ced88bd7851e647b1..0aef378921b05d86c25a8d0d02d4b5ab52720d4c
@@@ -2,11 -2,11 +2,12 @@@
  # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
 +
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) EPREFIX= ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       EPREFIX= ED=${D}
+ fi
  
  # we can't prefix all arguments because
  # chown takes random options
index 0824c15fc46369d7d75452b79c4785126310468e,d854ebbdfc1567a5c699fb45d28e1ae27e2684c7..94f6af22fa18deaa9cda3d2bb96c8a0b577fe1e8
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  # we can't prefix all arguments because
  # chmod takes random options
Simple merge
index 3aacb7f2adfb8b0a7faeaa70e0bbb8a1618d5e01,fb5c2db55f960b65892ea3742e91671489e58fde..407392f010f47a22533c692019f71b12d1cccec7
@@@ -1,13 -1,12 +1,14 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
 +
 +[[ -d ${ED} ]] || exit 0
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  if has chflags $FEATURES ; then
        # Save all the file flags for restoration at the end of prepall.
index 2804987efe7e37e9be3c147f55ef8ba316d7110c,3094661f5fbb7ff8a0633fc061108bbfa3287460..c7c85d62df3e24b9328b269663e4d6f9d81bab3f
@@@ -2,16 -2,12 +2,12 @@@
  # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- case "${EAPI}" in
-       0|1|2|3)
-               ;;
-       *)
-               die "'${0##*/}' has been banned for EAPI '$EAPI'"
-               exit 1
-               ;;
- esac
+ if ___eapi_has_docompress; then
+       die "'${0##*/}' has been banned for EAPI '$EAPI'"
+       exit 1
+ fi
  
  if [[ -n $1 ]] ; then
        __vecho "${0##*/}: invalid usage; takes no arguments" 1>&2
index 00e1fc41cc6923dc07091845f55410abb8161afc,1a20275801248b918137271648d7907ca5184ca7..43d0980b7b452c02acb06b6eef4054aebe51c4a1
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  [[ -d ${ED}usr/share/info ]] || exit 0
  
index fbc2f1dcfda1be2456ff4278b8d26693c2c348b7,7c78324cd83b4faff36cbfc2b118daadeb1a0e1f..4ad3a5eb4205951b2bde336feda28fb7c8a035af
@@@ -1,14 -1,15 +1,15 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  # replaced by controllable compression in EAPI 4
has "${EAPI}" 0 1 2 3 || exit 0
___eapi_has_docompress && exit 0
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  ret=0
  
index f99a15b0d8ee183af9d8e6ec0b6a6aa99d081bf4,1aa6686cda3e8e758d5aefa39276d5f740c7f246..d80f27ae150544d5d193a1ee10cadf3a466c3c94
@@@ -1,8 -1,11 +1,11 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
++source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  exec prepstrip "${ED}"
index 4ae497630384272f6cf4dfc8024738ff00047d10,5afc18a7164b4ed2e76961a2953ae0c67de21ed3..170e18a4734be395b4becd67bac880340a525b57
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  if [[ -z $1 ]] ; then
        infodir="/usr/share/info"
index 8e3d4b30ad66fe31df4e6d845ee202f3ed2cfd1a,764261d9888ad8f6993bb5aaf8feb7c6cc26f069..145540c618998beda80463c50643c83cf1613757
@@@ -1,8 -1,8 +1,8 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
  eqawarn "QA Notice: Deprecated call to 'preplib'"
  
index 1411499ab7430b438dcdbfd5c29de87ef25f6e37,142d40443a46dccd41bf0eadb421a152c51e35e8..add01c8782541b7c69dd7bf6218b85a4fb25eeb2
@@@ -1,11 -1,12 +1,12 @@@
 -#!/bin/bash
 +#!@PORTAGE_BASH@
- # Copyright 1999-2011 Gentoo Foundation
+ # Copyright 1999-2012 Gentoo Foundation
  # Distributed under the terms of the GNU General Public License v2
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"/isolated-functions.sh
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}"/isolated-functions.sh
  
- [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-       case "$EAPI" in 0|1|2) ED=${D} ;; esac
+ if ! ___eapi_has_prefix_variables; then
+       ED=${D}
+ fi
  
  if [[ -z $1 ]] ; then 
        mandir="${ED}usr/share/man"
Simple merge
diff --cc bin/ebuild.sh
Simple merge
Simple merge
index b66ded412f90305f190f05484354311e3728290c,986264ed8de3f237ed8b1b81c07f19db211dd828..3b2c3092b635320382380261618dd8866e1edded
mode 100644,100755..100644
  MISC_FUNCTIONS_ARGS="$@"
  shift $#
  
 -source "${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}/ebuild.sh"
 +source "${PORTAGE_BIN_PATH:-@PORTAGE_BASE@/bin}/ebuild.sh"
  
  install_symlink_html_docs() {
-       [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-               case "$EAPI" in 0|1|2) local ED=${D} ;; esac
-       # PREFIX LOCAL: ED needs not to exist, whereas D does
-       [[ ! -d ${ED} && -d ${D} ]] && dodir /
-       # END PREFIX LOCAL
+       if ! ___eapi_has_prefix_variables; then
+               local ED=${D}
++      else
++              # PREFIX LOCAL: ED needs not to exist, whereas D does
++              [[ ! -d ${ED} && -d ${D} ]] && dodir /
++              # END PREFIX LOCAL
+       fi
        cd "${ED}" || die "cd failed"
        #symlink the html documentation (if DOC_SYMLINKS_DIR is set in make.conf)
        if [ -n "${DOC_SYMLINKS_DIR}" ] ; then
@@@ -165,12 -164,11 +168,13 @@@ prepcompress() 
  
  install_qa_check() {
        local f i qa_var x
-       [[ " ${FEATURES} " == *" force-prefix "* ]] || \
-               case "$EAPI" in 0|1|2) local EPREFIX= ED=${D} ;; esac
+       if ! ___eapi_has_prefix_variables; then
+               local EPREFIX= ED=${D}
+       fi
  
 -      cd "${ED}" || die "cd failed"
 +      # PREFIX LOCAL: ED needs not to exist, whereas D does
 +      cd "${D}" || die "cd failed"
 +      # END PREFIX LOCAL
  
        qa_var="QA_FLAGS_IGNORED_${ARCH/-/_}"
        eval "[[ -n \${!qa_var} ]] && QA_FLAGS_IGNORED=(\"\${${qa_var}[@]}\")"
Simple merge
Simple merge
Simple merge
Simple merge
Simple merge
index 84e4494b91b859b701b43f84e358debdfc8ee9a0,9deed98d79fa3f68b7bcf6b87828a9a76c2d0b08..2db7900b17328bef3b3b41b125d4a8a9a0d673f3
@@@ -152,11 -150,18 +152,15 @@@ def _doebuild_path(settings, eapi=None)
        eprefix = settings["EPREFIX"]
        prerootpath = [x for x in settings.get("PREROOTPATH", "").split(":") if x]
        rootpath = [x for x in settings.get("ROOTPATH", "").split(":") if x]
 -
 -      prefixes = []
 -      if eprefix:
 -              prefixes.append(eprefix)
 -      prefixes.append("/")
 -
 +      # PREFIX LOCAL: use DEFAULT_PATH and EXTRA_PATH from make.globals
 +      defaultpath = [x for x in settings.get("DEFAULT_PATH", "").split(":") if x]
 +      extrapath = [x for x in settings.get("EXTRA_PATH", "").split(":") if x]
        path = []
  
+       if eprefix and uid != 0 and "fakeroot" not in settings.features:
+               path.append(os.path.join(portage_bin_path,
+                       "ebuild-helpers", "unprivileged"))
        if settings.get("USERLAND", "GNU") != "GNU":
                path.append(os.path.join(portage_bin_path, "ebuild-helpers", "bsd"))
  
Simple merge